<html>
<head>
<title>Ogre::GLSLLinkProgramManager Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html">GLSLLinkProgramManager</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-static-attribs">Static Protected Attributes</a> &#124;
<a href="#pri-types">Private Types</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::GLSLLinkProgramManager Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::GLSLLinkProgramManager" --><!-- doxytag: inherits="Singleton&lt; GLSLLinkProgramManager &gt;" -->
<p><a class="el" href="namespaceOgre.html">Ogre</a> assumes that there are separate vertex and fragment programs to deal with but GLSL has one program object that represents the active vertex and fragment shader objects during a rendering state.  
 <a href="classOgre_1_1GLSLLinkProgramManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::GLSLLinkProgramManager:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1GLSLLinkProgramManager__inherit__graph.gif" border="0" usemap="#Ogre_1_1GLSLLinkProgramManager_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1GLSLLinkProgramManager_inherit__map" id="Ogre_1_1GLSLLinkProgramManager_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1Singleton.html" title="Ogre::Singleton\&lt; GLSLLinkProgramManager \&gt;" alt="" coords="5,5,296,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1GLSLLinkProgramManager-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#ad8089caecf3cafc51df61c41b651f682">GLSLLinkProgramManager</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a3adcf559517dcd78cbe9025a2650cedb">~GLSLLinkProgramManager</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLLinkProgram.html">GLSLLinkProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a47caaf97c826c59d997b749ae8d034e3">getActiveLinkProgram</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the program object that links the two active shader objects together if a program object was not already created and linked a new one is created and linked.  <a href="#a47caaf97c826c59d997b749ae8d034e3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#ad820f7ab1789e21eb83e953ab4035312">setActiveFragmentShader</a> (<a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a> *fragmentGpuProgram)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the active fragment shader for the next rendering state.  <a href="#ad820f7ab1789e21eb83e953ab4035312"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a174da94ec2d76ed2a50a542042449156">setActiveGeometryShader</a> (<a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a> *geometryGpuProgram)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the active geometry shader for the next rendering state.  <a href="#a174da94ec2d76ed2a50a542042449156"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a6dc5050b4d308840a85a5634708420b6">setActiveVertexShader</a> (<a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a> *vertexGpuProgram)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the active vertex shader for the next rendering state.  <a href="#a6dc5050b4d308840a85a5634708420b6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#aa5e221555166193468134f8d502a9172">extractUniforms</a> (GLhandleARB programObject, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *vertexConstantDefs, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *geometryConstantDefs, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *fragmentConstantDefs, <a class="el" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a> &amp;<a class="el" href="structOgre_1_1list.html">list</a>)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Populate a list of uniforms based on a program object.  <a href="#aa5e221555166193468134f8d502a9172"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#ad955055c153be870a9f30e465c7f1859">extractConstantDefs</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;src, <a class="el" href="structOgre_1_1GpuNamedConstants.html">GpuNamedConstants</a> &amp;constantDefs, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;filename)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Populate a list of uniforms based on GLSL source.  <a href="#ad955055c153be870a9f30e465c7f1859"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html">GLSLLinkProgramManager</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a47ecd1f88258a06dfae69b8bb9a698da">getSingleton</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html">GLSLLinkProgramManager</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a445e7c1c68ee15e8e99fbdc00cb70333">getSingletonPtr</a> (void)</td></tr>
<tr><td colspan="2"><h2><a name="pro-static-attribs"></a>
Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html">GLSLLinkProgramManager</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a></td></tr>
<tr><td colspan="2"><h2><a name="pri-types"></a>
Private Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>, <br class="typebreak"/>
<a class="el" href="classOgre_1_1GLSLLinkProgram.html">GLSLLinkProgram</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a72b9d32bf15126b4368cb0858297ad47">LinkProgramMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef LinkProgramMap::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a5d934f329bb59c6d8161d87bee02c991">LinkProgramIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, GLenum &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a9f09464371a11c39ae51a42207892160">StringToEnumMap</a></td></tr>
<tr><td colspan="2"><h2><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a6bdd91bf30135d45a55cd5d571f86eea">completeDefInfo</a> (GLenum gltype, <a class="el" href="structOgre_1_1GpuConstantDefinition.html">GpuConstantDefinition</a> &amp;defToUpdate)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Use type to complete other information.  <a href="#a6bdd91bf30135d45a55cd5d571f86eea"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a9cf8bedf888dbf1740c77ca06026b748">completeParamSource</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;paramName, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *vertexConstantDefs, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *geometryConstantDefs, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *fragmentConstantDefs, <a class="el" href="structOgre_1_1GLUniformReference.html">GLUniformReference</a> &amp;refToUpdate)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Find where the data for a specific uniform should come from, populate.  <a href="#a9cf8bedf888dbf1740c77ca06026b748"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a72b9d32bf15126b4368cb0858297ad47">LinkProgramMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a31eb5bea7006d830b5f98cc9f334511f">mLinkPrograms</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">container holding previously created program objects  <a href="#a31eb5bea7006d830b5f98cc9f334511f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#accc8e3da6656fc3378d5deeb82aadc48">mActiveVertexGpuProgram</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">active objects defining the active rendering gpu state  <a href="#accc8e3da6656fc3378d5deeb82aadc48"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#aabf8c925ca4474e1523ebb6f393dcb64">mActiveGeometryGpuProgram</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a19e4eaaf2edebbe6097b5976ded7ae09">mActiveFragmentGpuProgram</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLLinkProgram.html">GLSLLinkProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#aee6e3ebb3971970af8e2b7099b7d5cee">mActiveLinkProgram</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a9f09464371a11c39ae51a42207892160">StringToEnumMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#aab4a7fd5ccea9b632513b67c69c16501">mTypeEnumMap</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p><a class="el" href="namespaceOgre.html">Ogre</a> assumes that there are separate vertex and fragment programs to deal with but GLSL has one program object that represents the active vertex and fragment shader objects during a rendering state. </p>
<p>GLSL Vertex and fragment shader objects are compiled separately and then attached to a program object and then the program object is linked. Since <a class="el" href="namespaceOgre.html">Ogre</a> can only handle one vertex program and one fragment program being active in a pass, the GLSL Link Program Manager does the same. The GLSL Link program manager acts as a state machine and activates a program object based on the active vertex and fragment program. Previously created program objects are stored along with a unique key in a hash_map for quick retrieval the next time the program object is required. </p>

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00052">52</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a5d934f329bb59c6d8161d87bee02c991"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::LinkProgramIterator" ref="a5d934f329bb59c6d8161d87bee02c991" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef LinkProgramMap::iterator <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a5d934f329bb59c6d8161d87bee02c991">Ogre::GLSLLinkProgramManager::LinkProgramIterator</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00058">58</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a72b9d32bf15126b4368cb0858297ad47"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::LinkProgramMap" ref="a72b9d32bf15126b4368cb0858297ad47" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>, <a class="el" href="classOgre_1_1GLSLLinkProgram.html">GLSLLinkProgram</a>*&gt;::type <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a72b9d32bf15126b4368cb0858297ad47">Ogre::GLSLLinkProgramManager::LinkProgramMap</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00057">57</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9f09464371a11c39ae51a42207892160"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::StringToEnumMap" ref="a9f09464371a11c39ae51a42207892160" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, GLenum&gt;::type <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a9f09464371a11c39ae51a42207892160">Ogre::GLSLLinkProgramManager::StringToEnumMap</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00069">69</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ad8089caecf3cafc51df61c41b651f682"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::GLSLLinkProgramManager" ref="ad8089caecf3cafc51df61c41b651f682" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#ad8089caecf3cafc51df61c41b651f682">Ogre::GLSLLinkProgramManager::GLSLLinkProgramManager</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a3adcf559517dcd78cbe9025a2650cedb"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::~GLSLLinkProgramManager" ref="a3adcf559517dcd78cbe9025a2650cedb" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a3adcf559517dcd78cbe9025a2650cedb">Ogre::GLSLLinkProgramManager::~GLSLLinkProgramManager</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a6bdd91bf30135d45a55cd5d571f86eea"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::completeDefInfo" ref="a6bdd91bf30135d45a55cd5d571f86eea" args="(GLenum gltype, GpuConstantDefinition &amp;defToUpdate)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a6bdd91bf30135d45a55cd5d571f86eea">Ogre::GLSLLinkProgramManager::completeDefInfo</a> </td>
          <td>(</td>
          <td class="paramtype">GLenum&#160;</td>
          <td class="paramname"><em>gltype</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structOgre_1_1GpuConstantDefinition.html">GpuConstantDefinition</a> &amp;&#160;</td>
          <td class="paramname"><em>defToUpdate</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Use type to complete other information. </p>

</div>
</div>
<a class="anchor" id="a9cf8bedf888dbf1740c77ca06026b748"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::completeParamSource" ref="a9cf8bedf888dbf1740c77ca06026b748" args="(const String &amp;paramName, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *geometryConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReference &amp;refToUpdate)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a9cf8bedf888dbf1740c77ca06026b748">Ogre::GLSLLinkProgramManager::completeParamSource</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>paramName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>vertexConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>geometryConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>fragmentConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structOgre_1_1GLUniformReference.html">GLUniformReference</a> &amp;&#160;</td>
          <td class="paramname"><em>refToUpdate</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Find where the data for a specific uniform should come from, populate. </p>

</div>
</div>
<a class="anchor" id="ad955055c153be870a9f30e465c7f1859"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::extractConstantDefs" ref="ad955055c153be870a9f30e465c7f1859" args="(const String &amp;src, GpuNamedConstants &amp;constantDefs, const String &amp;filename)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#ad955055c153be870a9f30e465c7f1859">Ogre::GLSLLinkProgramManager::extractConstantDefs</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structOgre_1_1GpuNamedConstants.html">GpuNamedConstants</a> &amp;&#160;</td>
          <td class="paramname"><em>constantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>filename</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Populate a list of uniforms based on GLSL source. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>Reference to the source code </td></tr>
    <tr><td class="paramname">list</td><td>The defs to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want). </td></tr>
    <tr><td class="paramname">filename</td><td>The file name this came from, for logging errors. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa5e221555166193468134f8d502a9172"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::extractUniforms" ref="aa5e221555166193468134f8d502a9172" args="(GLhandleARB programObject, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *geometryConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReferenceList &amp;list)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#aa5e221555166193468134f8d502a9172">Ogre::GLSLLinkProgramManager::extractUniforms</a> </td>
          <td>(</td>
          <td class="paramtype">GLhandleARB&#160;</td>
          <td class="paramname"><em>programObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>vertexConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>geometryConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>fragmentConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a> &amp;&#160;</td>
          <td class="paramname"><em>list</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Populate a list of uniforms based on a program object. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">programObject</td><td>Handle to the program object to query </td></tr>
    <tr><td class="paramname">vertexConstantDefs</td><td>Definition of the constants extracted from the vertex program, used to match up physical buffer indexes with program uniforms. May be null if there is no vertex program. </td></tr>
    <tr><td class="paramname">geometryConstantDefs</td><td>Definition of the constants extracted from the geometry program, used to match up physical buffer indexes with program uniforms. May be null if there is no geometry program. </td></tr>
    <tr><td class="paramname">fragmentConstantDefs</td><td>Definition of the constants extracted from the fragment program, used to match up physical buffer indexes with program uniforms. May be null if there is no fragment program. </td></tr>
    <tr><td class="paramname">list</td><td>The list to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a47caaf97c826c59d997b749ae8d034e3"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::getActiveLinkProgram" ref="a47caaf97c826c59d997b749ae8d034e3" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLLinkProgram.html">GLSLLinkProgram</a>* <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a47caaf97c826c59d997b749ae8d034e3">Ogre::GLSLLinkProgramManager::getActiveLinkProgram</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the program object that links the two active shader objects together if a program object was not already created and linked a new one is created and linked. </p>

</div>
</div>
<a class="anchor" id="a47ecd1f88258a06dfae69b8bb9a698da"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::getSingleton" ref="a47ecd1f88258a06dfae69b8bb9a698da" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html">GLSLLinkProgramManager</a>&amp; <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a47ecd1f88258a06dfae69b8bb9a698da">Ogre::GLSLLinkProgramManager::getSingleton</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#a7757bd7ac3702c144502e53ad6491888">Ogre::Singleton&lt; GLSLLinkProgramManager &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="a445e7c1c68ee15e8e99fbdc00cb70333"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::getSingletonPtr" ref="a445e7c1c68ee15e8e99fbdc00cb70333" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html">GLSLLinkProgramManager</a>* <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a445e7c1c68ee15e8e99fbdc00cb70333">Ogre::GLSLLinkProgramManager::getSingletonPtr</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#a7ab51c46521b89723d6186a52a7e0d7b">Ogre::Singleton&lt; GLSLLinkProgramManager &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="ad820f7ab1789e21eb83e953ab4035312"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::setActiveFragmentShader" ref="ad820f7ab1789e21eb83e953ab4035312" args="(GLSLGpuProgram *fragmentGpuProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#ad820f7ab1789e21eb83e953ab4035312">Ogre::GLSLLinkProgramManager::setActiveFragmentShader</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a> *&#160;</td>
          <td class="paramname"><em>fragmentGpuProgram</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the active fragment shader for the next rendering state. </p>
<p>The active program object will be cleared. Normally called from the <a class="el" href="classOgre_1_1GLSLGpuProgram.html#aafeaa9fcb713f503cbd84a75c2269326" title="Execute the binding functions for this program.">GLSLGpuProgram::bindProgram</a> and unbindProgram methods </p>

</div>
</div>
<a class="anchor" id="a174da94ec2d76ed2a50a542042449156"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::setActiveGeometryShader" ref="a174da94ec2d76ed2a50a542042449156" args="(GLSLGpuProgram *geometryGpuProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a174da94ec2d76ed2a50a542042449156">Ogre::GLSLLinkProgramManager::setActiveGeometryShader</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a> *&#160;</td>
          <td class="paramname"><em>geometryGpuProgram</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the active geometry shader for the next rendering state. </p>
<p>The active program object will be cleared. Normally called from the <a class="el" href="classOgre_1_1GLSLGpuProgram.html#aafeaa9fcb713f503cbd84a75c2269326" title="Execute the binding functions for this program.">GLSLGpuProgram::bindProgram</a> and unbindProgram methods </p>

</div>
</div>
<a class="anchor" id="a6dc5050b4d308840a85a5634708420b6"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::setActiveVertexShader" ref="a6dc5050b4d308840a85a5634708420b6" args="(GLSLGpuProgram *vertexGpuProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a6dc5050b4d308840a85a5634708420b6">Ogre::GLSLLinkProgramManager::setActiveVertexShader</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a> *&#160;</td>
          <td class="paramname"><em>vertexGpuProgram</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the active vertex shader for the next rendering state. </p>
<p>The active program object will be cleared. Normally called from the <a class="el" href="classOgre_1_1GLSLGpuProgram.html#aafeaa9fcb713f503cbd84a75c2269326" title="Execute the binding functions for this program.">GLSLGpuProgram::bindProgram</a> and unbindProgram methods </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a19e4eaaf2edebbe6097b5976ded7ae09"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::mActiveFragmentGpuProgram" ref="a19e4eaaf2edebbe6097b5976ded7ae09" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a>* <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a19e4eaaf2edebbe6097b5976ded7ae09">Ogre::GLSLLinkProgramManager::mActiveFragmentGpuProgram</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00066">66</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="aabf8c925ca4474e1523ebb6f393dcb64"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::mActiveGeometryGpuProgram" ref="aabf8c925ca4474e1523ebb6f393dcb64" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a>* <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#aabf8c925ca4474e1523ebb6f393dcb64">Ogre::GLSLLinkProgramManager::mActiveGeometryGpuProgram</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00065">65</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="aee6e3ebb3971970af8e2b7099b7d5cee"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::mActiveLinkProgram" ref="aee6e3ebb3971970af8e2b7099b7d5cee" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLLinkProgram.html">GLSLLinkProgram</a>* <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#aee6e3ebb3971970af8e2b7099b7d5cee">Ogre::GLSLLinkProgramManager::mActiveLinkProgram</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00067">67</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="accc8e3da6656fc3378d5deeb82aadc48"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::mActiveVertexGpuProgram" ref="accc8e3da6656fc3378d5deeb82aadc48" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLGpuProgram.html">GLSLGpuProgram</a>* <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#accc8e3da6656fc3378d5deeb82aadc48">Ogre::GLSLLinkProgramManager::mActiveVertexGpuProgram</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>active objects defining the active rendering gpu state </p>

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00064">64</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a31eb5bea7006d830b5f98cc9f334511f"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::mLinkPrograms" ref="a31eb5bea7006d830b5f98cc9f334511f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a72b9d32bf15126b4368cb0858297ad47">LinkProgramMap</a> <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a31eb5bea7006d830b5f98cc9f334511f">Ogre::GLSLLinkProgramManager::mLinkPrograms</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>container holding previously created program objects </p>

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00061">61</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="aff0baaaed91d8505cfb72b7725ae1c37"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::msSingleton" ref="aff0baaaed91d8505cfb72b7725ae1c37" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html">GLSLLinkProgramManager</a> * <a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html">GLSLLinkProgramManager</a>  &gt;::<a class="el" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a><code> [static, protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSingleton_8h_source.html#l00075">75</a> of file <a class="el" href="OgreSingleton_8h_source.html">OgreSingleton.h</a>.</p>

</div>
</div>
<a class="anchor" id="aab4a7fd5ccea9b632513b67c69c16501"></a><!-- doxytag: member="Ogre::GLSLLinkProgramManager::mTypeEnumMap" ref="aab4a7fd5ccea9b632513b67c69c16501" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#a9f09464371a11c39ae51a42207892160">StringToEnumMap</a> <a class="el" href="classOgre_1_1GLSLLinkProgramManager.html#aab4a7fd5ccea9b632513b67c69c16501">Ogre::GLSLLinkProgramManager::mTypeEnumMap</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html#l00070">70</a> of file <a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreGLSLLinkProgramManager_8h_source.html">OgreGLSLLinkProgramManager.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:22
</p>
</body>
</html>
